#!/usr/bin/perl
#
# This code is distributed under the terms of the GPL
#
# (c) Tiago Freitas Leal
#
###2004-0422 - Modded by catastrophe for use with Quikview v.0.1
###2004-0509 - Modded by catastrophe for use with Quikview v.0.2
###2004-0919 - Modded by catastrophe for use with Quikview v.0.3


# # # # # # # # # # # # # # # # # # #
# check for existing installations  #
# # # # # # # # # # # # # # # # # # #

print "\nInstalling Quikview v.0.3, please wait...\n\n";

if (&installed ("/var/smoothwall/langs/base.pl", "# quikview v.0.3")) {
	print "Please remove Quikview pack v.0.3\n ";
	print "Note - Run uninstall.pl script.\n \n";
	exit;
}

if (&installed ("/var/smoothwall/langs/base.pl", "# quikview v.0.2")) {
	print "Please remove Quikview pack v.0.2\n ";
	print "Note - Run uninstall-02.pl script.\n \n";
	exit;
}

if (&installed ("/var/smoothwall/langs/base.pl", "# quikview v.0.1")) {
	print "Please remove Quikview pack v.0.1\n ";
	print "Note - Run uninstall-01.pl script.\n \n";
	exit;
}

# # # # # # # # # # # #
# handle file copying #
# # # # # # # # # # # #

#	backupinstall ($file ,$wkdir ,$storebkp ,$moddir);
#	install ($file ,$wkdir ,$moddir);

my $bkp = '/var/smoothwall/mods/quikview/backup';

my $mod = '/var/smoothwall/mods/quikview/modfiles';

$dir = '/home/httpd/cgi-bin';
#&backupinstall ('quikview.cgi' ,$dir ,$bkp ,$mod);
#&backup ('quikview.cgi' ,$dir ,$bkp);
&install ('quikview.cgi' ,$dir ,$mod);

$dir = '/home/httpd/html/help';
#&backupinstall ('quikview.cgi.html.en' ,$dir ,$bkp ,$mod);
&install ('quikview.cgi.html.en' ,$dir ,$mod);

# remove these lines when the web UI interface is ready
open (FILE, ">/var/smoothwall/preferences/dummy") or system ("/bin/su nobody -c '/bin/mkdir /var/smoothwall/preferences'");
close (FILE);
system ("/bin/rm -f /var/smoothwall/preferences/dummy");

# uncomment these lines when the web UI interface is ready
#open (FILE, ">/var/smoothwall/preferences/dummy") or system ("/bin/mkdir /var/smoothwall/preferences");
#close (FILE);
#system ("/bin/rm -f /var/smoothwall/preferences/dummy");

$dir = '/var/smoothwall/preferences';
#&backupinstall ('quikview-default' ,$dir ,$bkp ,$mod);
&install ('quikview-default' ,$dir ,$mod);
if (-e "$dir/quikview-custom") {
	print "Note - quikview-custom already exists, a newer version of the file\n  will not be copied in order to maintain your previous settings\n \n";
} else {
	&install ('quikview-custom' ,$dir ,$mod);
}


# # # # # # # # # # # #
# handle file editing #
# # # # # # # # # # # #

my $param = '/var/smoothwall/mods/quikview/params';

&easymod ("/var/smoothwall/main/ui/alertboxes.en.pl", "$param/alertboxes.en.pl.01.s",'0',"$param/alertboxes.en.pl.01.r");

&easymod ("/var/smoothwall/langs/base.pl", "$param/base.pl.03.s",'0',"$param/base.pl.03.r");

&easymod ("/var/smoothwall/header.pl", "$param/header.pl.02.s",'0',"$param/header.pl.02.r");

&easymod ("/home/httpd/cgi-bin/.htaccess", "$param/htaccess.01.s",'3',"$param/htaccess.01.r");

#&easymod ("/var/smoothwall/mods.pl", "$param/mods.pl.01.s",'0',"$param/mods.pl.01.r");

# # # # # # # # # # # #
# handle file linking #
# # # # # # # # # # # #

system '/bin/ln -s /home/httpd/html/ui/assets/3.6/img/pagetitles/title-logs.png /home/httpd/html/ui/assets/3.6/img/pagetitles/page-quikview.png';

# # # #
# end #
# # # #

#
# This code is distributed under the terms of the GPL
#
# (c) Tiago Freitas Leal

$version = '2.1';

#	$storebkp =	where to store backup of the files that are changed by your mod
#	$moddir =	where your mod files are
#	$wkdir =	where you are changing files (backup from and copy to)
#
#	backupinstall ($file ,$wkdir ,$storebkp ,$moddir);
#	backup ($file ,$wkdir ,$storebkp);
#	install ($file ,$wkdir ,$moddir);
#	uninstallrestore ($file ,$wkdir ,$storebkp);
#	uninstall ($file  ,$wkdir);
#
#	installed ($file, $string);
#
#	search for $string into $file => 1 found / 0 not found

sub backupinstall
{
	my $file = $_[0];
	my $wkdir = $_[1];
	my $storebkp = $_[2];
	my $moddir = $_[3];
#	system "/bin/cp -p $wkdir/$file $storebkp/$file";
#	system "/bin/cp $moddir/$file $wkdir/$file";
	system "/bin/cp -p $moddir/$file $wkdir/$file";
}

sub backup
{
	my $file = $_[0];
	my $wkdir = $_[1];
	my $storebkp = $_[2];
	system "/bin/cp -p $wkdir/$file $storebkp/$file";
}

sub install
{
	my $file = $_[0];
	my $wkdir = $_[1];
	my $moddir = $_[2];
	system "/bin/cp -p $moddir/$file $wkdir/$file";
}

sub uninstallrestore
{
	my $file = $_[0];
	my $wkdir = $_[1];
	my $storebkp = $_[2];
	system "/bin/cp -p $storebkp/$file $wkdir/$file";
#	system "/bin/rm -f $storebkp/$file";
}

sub uninstall
{
	my $file = $_[0];
	my $wkdir = $_[1];
	system "/bin/rm -f $wkdir/$file";
}

sub easymod
{
	my $targetfile = $_[0];
	my $searchfile = $_[1];
	my $linestodelete = $_[2];
	my $replacefile = $_[3];

	open(TARGET, "$targetfile") or die 'Unable to open target file.';
	my @target = <TARGET>;
	close(TARGET);

	open(SEARCH, "$searchfile") or die 'Unable to open search file';
	my @search = <SEARCH>;
	close(SEARCH);

	open(REPLACE, "$replacefile") or die 'Unable to open replace file.';
	my @replace = <REPLACE>;
	close(REPLACE);

	open(TEMP, ">/tmp/temp") or die 'Unable to open temporary file.';
	flock TEMP, 2;

	my $found = 0;
	my $line;
	foreach $line (@target)
	{
		if ($found == 0)
		{
			if ($line eq "@search")
			{
				$found = 1;
				if ($linestodelete > 0)
				{
					$linestodelete--;
				}
				else {print TEMP "$line"; }
				my $repline;
				foreach $repline (@replace) {print TEMP $repline; }
			}
			else {print TEMP "$line"; }
		}
		else
		{
			if ($linestodelete > 0)
			{
				$linestodelete--;
			}
			else {print TEMP "$line"; }
		}
	}	
	close(TEMP);
	system "/bin/cp /tmp/temp $targetfile";
	system "/bin/rm -f /tmp/temp";
}

sub installed
{
	my $targetfile = $_[0];
	my $searchstring = $_[1];

	open(TARGET, "$targetfile") or die 'Unable to open target file.';
	my @target = <TARGET>;
	close(TARGET);

	my $line;
	foreach $line (@target)
	{
		if ($line eq "$searchstring\n")
		{
			return 1;
		}
	}	
	return 0;
}
